Unit InOut;

interface

 uses
   CRT;

 procedure ClearRow(x, y : byte);
 procedure PutString(x, y : byte; Str : string);
 procedure PutError(Msg : string);
 procedure ReadReal(var Value : real);
 procedure ReadRealXY(x, y : byte; Prompt : string;  var Value : real);
 procedure ReadInt(var Value : integer);
 procedure ReadIntXY(x, y : byte; Prompt : string;  var Value : integer);
 procedure WriteRealXY(x, y : byte; Prompt : string;  Value : real;
                                                      Space, Dec : shortint);
 procedure WriteIntXY(x, y : byte; Prompt : string;  Value : integer;
                                                           Space : byte);

implementation

 procedure ClearRow(x, y : byte);
  begin  { ClearRow }
    GotoXY(x, y);  ClrEol;
  end;  { ClearRow }

 procedure PutString(x, y : byte; Str : string);
  begin { PutString }
    GotoXY(x, y); write(Str);
  end;  { PutString }

 procedure PutError(Msg : string);
  var
    AnyChar : char;
  begin  { PutError }
    PutString(10, 25, Msg);
    AnyChar := ReadKey;
    ClearRow(10, 25);
  end;  { PutError }

 procedure CheckCode(x, y : byte; s : string; Code : integer);
  begin  { CheckCode }
    if (Code <> 0)  then
      begin
        write(#7);
        PutError('  ᨬ '+s[Code]);
        ClearRow(x, y);
      end;
  end;  { CheckCode }

  procedure ReadReal(var Value : real);
  var
    s    : string;
    Code : integer;
    x, y : byte;
  begin  { ReadReal }
    x := WhereX; y := WhereY;
    repeat
      readln(s);
      Val(s, Value, Code);
      CheckCode(x, y, s, Code);
    until (Code = 0);
  end;  { ReadReal }

 procedure ReadRealXY(x, y : byte; Prompt : string;  var Value : real);
  begin  { ReadRealXY }
    PutString(x, y, Prompt);
    ReadReal(Value);
  end;  { ReadRealXY }


 procedure ReadInt(var Value : integer);
  var
    s    : string;
    Code : integer;
    x, y : byte;
  begin  { ReadInt }
    x := WhereX; y := WhereY;
    repeat
      readln(s);
      Val(s, Value, Code);
      CheckCode(x, y, s, Code);
    until (Code = 0);
  end;  { ReadInt }

 procedure ReadIntXY(x, y : byte; Prompt : string;  var Value : integer);
  begin  { ReadIntXY }
    PutString(x, y, Prompt);
    ReadInt(Value);
  end;  { ReadInt }

 procedure WriteRealXY(x, y : byte; Prompt : string;  Value : real;
                                                      Space, Dec : shortint);
  begin  { WriteRealXY }
    PutString(x, y, Prompt);
    if (Dec < 0)  then
      write(Value:Space)
    else
      write(Value:Space:Dec);
  end;  { WriteRealXY }
 procedure WriteIntXY(x, y : byte; Prompt : string;  Value : integer;
                                                           Space : byte);
  begin  { WriteIntXY }
    PutString(x, y, Prompt);  write(Value:Space);
  end;  { WriteIntXY }

end.  { InOut }
