Unit InOut;
interface
 uses  Crt, Matrix;

type  Str8  = string[8];

  procedure ClearRow ( x, y : byte);
                     { ⪠ ப y  樨 x }
  procedure PutString( x, y : byte; Str : string);
                     { 뢮 ப   y  ⮫ x }
  procedure PutError ( Msg : string);
                     { 뢮 ப ᮮ饭 }
  procedure ReadInt ( var Value : integer);
                     {  楫 ᫠ }
  procedure ReadIntXY( x, y : byte; Prompt : string;  var Value : integer);
                     {  楫 ᫠ c 뤠祩 ᪠ }
                     {  ப y,⮫ x                  }
  procedure ReadReal (var Value : real);
                     {  ⢭ ᫠ }
  procedure ReadRealXY( x, y : byte; Prompt : string;  var Value : real);
                      {  e ᫠ c 뤠祩 ᪠ }
                      {  ப y,⮫ x                         }
  procedure WriteRealXY(x, y : byte; Prompt : string;  Value : real;
                                                      Space, Dec : shortint);
  { 뢮 e ᫠ c 뤠祩 ᪠  ப y,⮫ x }
  {              Space -᫮ 権, Dec-᫮  ᫥ ⮩  }
  {                 Dec < 0 - 뤠  ᯮ樠쭮 ଠ     }

  procedure WriteIntXY(x, y : byte; Prompt : string;  Value : integer;
                                                           Space : byte);
  { 뢮 楫 ᫠ c 뤠祩 ᪠  ப y,⮫ x }
  {              Space -᫮ 権                           }

  procedure ReadArr(j,ii : byte; Name : Str8; n : byte; var a : TNvector);
   {  c 뤠祩 ᪠ (max - 8 ᨬ)  i ப  j ⮫ }
   { n ⮢ ᨢ                                               }

  procedure WriteArr(j,ii : byte; Name : Str8; n : byte; var a : TNvector);
   { 뢮 c 뤠祩 ᪠ (max - 8 ᨬ)  i ப  j ⮫ }
   { n ⮢ ᨢ                                                }

  function Min(n : byte; var a : TNvector) : real;
               {    a  n ⮢ }

  function Max(n : byte; var a : TNvector) : real;
               { ᨬ   a  n ⮢ }

  function SumArr(n : byte; var a : TNvector) : real;
               { 㬬 ⮢  a  n ⮢ }

  function AverageArr(n : byte; var a : TNvector) : real;
               { । 祭 ⮢  a  n ⮢ }

  procedure ReadMatr(x,y:byte; Name : Str8; n,m : byte; var a : TNMatrix);
               {  ⮢  a ࠧ୮ n*m               }
               {             c 뤠祩 ᪠  ப y,⮫ x    }

  procedure WriteMatr(x,y:byte; Name : Str8; n,m : byte; var a : TNMatrix);
               { 뢮 ⮢  a ࠧ୮ n*m               }
               {              c 뤠祩 ᪠  ப y,⮫ x    }

implementation

 procedure ClearRow(x, y : byte);
  begin
    GotoXY(x, y);  ClrEol;
  end;  { ClearRow }

 procedure PutString(x, y : byte; Str : string);
  begin
    GotoXY(x, y); write(Str);
  end;  { PutString }

 procedure PutError(Msg : string);
  var
    AnyChar : char;
  begin
    PutString(10, 25, Msg);  AnyChar := ReadKey;   ClearRow(10, 25);
  end;  { PutError }

 procedure CheckCode(x, y : byte; s : string; Code : integer);
  begin
   if (Code <> 0)  then
    begin
     write(#7); PutError('  ᨬ '+s[Code]); ClearRow(x, y);
    end;
  end;  { CheckCode }

  procedure ReadReal(var Value : real);
  var
    s    : string;
    Code : integer;
    x, y : byte;
  begin
    x := WhereX; y := WhereY;
    repeat
      readln(s); Val(s, Value, Code);  CheckCode(x, y, s, Code);
    until (Code = 0);
  end;  { ReadReal }

 procedure ReadRealXY(x, y : byte; Prompt : string;  var Value : real);
  begin
    PutString(x, y, Prompt);  ReadReal(Value);
  end;  { ReadRealXY }


 procedure ReadInt(var Value : integer);
  var
    s    : string;
    Code : integer;
    x, y : byte;
  begin
    x := WhereX; y := WhereY;
    repeat
      readln(s);   Val(s, Value, Code);   CheckCode(x, y, s, Code);
    until (Code = 0);
  end;  { ReadInt }

 procedure ReadIntXY(x, y : byte; Prompt : string;  var Value : integer);
  begin
    PutString(x, y, Prompt);   ReadInt(Value);
  end;  { ReadInt }

 procedure WriteRealXY(x, y : byte; Prompt : string;  Value : real;
                                                      Space, Dec : shortint);
  begin
    PutString(x, y, Prompt);
    if (Dec < 0)  then write(Value:Space) else write(Value:Space:Dec);
  end;  { WriteRealXY }

 procedure WriteIntXY(x, y : byte; Prompt : string;  Value : integer;
                                                           Space : byte);
  begin
    PutString(x, y, Prompt);  write(Value:Space);
  end;  { WriteIntXY }

 procedure ReadArr(j,ii : byte; Name : Str8; n : byte; var a : TNvector);
   var
    i  : byte;
  begin
    PutString(j,ii,Name);
    for i := 1 to n  do
      ReadRealXY(j,ii+i,'',a[i]);
  end;

 procedure WriteArr(j,ii : byte; Name : Str8; n : byte; var a : TNvector);
  var
    i  : byte;
  begin
    PutString(j,ii,Name);
    for i := 1 to n  do
     WriteRealXY(j,ii+i,'', a[i],6,2);
  end;

 function Min(n : byte; var a : TNvector) : real;
  var
    i    : byte;
    amin : real;
  begin
    amin := a[1];
    for  i:= 1 to n  do   if (a[i] < amin)  then  amin := a[i];
    Min := amin;
  end;  { Min }

 function Max(n : byte; var a : TNvector) : real;
  var
    i    : byte;
    amax : real;
  begin
    amax := a[1];
    for  i:= 1 to n  do  if (a[i] > amax)  then  amax := a[i];
    Max := amax;
  end;  { Max }

 function SumArr(n : byte; var a : TNvector) : real;
  var
    i : byte;
    s : real;
  begin
    s := 0;
    for i := 1 to n  do  s := s + a[i];
    SumArr := s;
  end;  { SumArr }

 function AverageArr(n : byte; var a : TNvector) : real;
  begin
    AverageArr := SumArr(n, a) / n;
  end;  { AverageArr }

  procedure ReadMatr(x,y:byte; Name : Str8; n,m : byte; var a : TNMatrix);
   var
    i,j  : byte;
  begin
    GotoXY(x,y); write(Name);
    for i := 1 to n  do
     begin
      for j:=1 to m do
       begin GotoXY(x+10*(j-1),y+1+i);  ReadReal(a[i,j]); end;
      end;
  end;

  procedure WriteMatr(x,y:byte; Name : Str8; n,m : byte; var a : TNMatrix);
  var
    i,j  : byte;
  begin
    GotoXY(x,y); write(Name);
    for i := 1 to n  do
     begin
      for j:=1 to m do
       begin GotoXY(x+10*(j-1),y+1+i);  Write(a[i,j]:7:4); end;
      end;
  end;
end.


