Unit MatrixEx;

 interface     {   樨 }
  uses matrix;

procedure TransposeMatrix ( n,m : byte;
                             a : TNMatrix;
                        var at : TNMatrix );    {  a      -->   at          }
                                                {   n x m         m x n     }
procedure MultiplicMatrixs ( n,m,k: byte;
                            a,b   : TNMatrix;
                        var c     : TNMatrix ); { a      . b   ---> c       }
                                                {   n x m   m x k     n x k }
procedure AddMatrixs     ( n,m : byte;
                           a,b : TNMatrix;
                       var c   : TNMatrix );    { a      + b   ---> c       }
                                                {   n x m   n x m     n x m }

procedure MultiplicMatVec ( n,m : byte;
                            a   : TNMatrix;
                            b   : TNVector;
                        var c   : TNVector );   { a      . b   ---> c       }
                                                {   n x m   m        n      }

procedure MultiplicVecMat ( n,m : byte;
                            a   : TNVector;
                            b   : TNMatrix;
                        var c   : TNVector );   { a  . b   ---> c       }
                                                {   n   n x m     m     }

function Sled (n : byte; a : TNMatrix) : real;

procedure AddVectors     ( n   : byte;
                           a,b : TNVector;
                       var c   : TNVector );    { a   + b   ---> c       }
                                                {   n    n        n      }
procedure MultiplicVecvec (m,n:byte; a,b:TNVector; var c:TNMatrix);

function NormaOfMatrix (n,m : byte; a : TNMatrix) : real;

function NormaOfVector ( n : byte; a : TNVector) : real;

function Scalar ( n : byte; a,b : TNVector) : real;


implementation


procedure TransposeMatrix (n,m:byte; a:TNMatrix; var at:TNMatrix);
var i,j : byte;
begin
  for i:=1 to m do
    for j:=1 to n do at[i,j]:=a[j,i];
end; { TransposeMatrix }

procedure MultiplicMatrixs (n,m,k:byte; a,b:TNMatrix; var c:TNMatrix);
var i,j,l : byte;
begin
  for i:=1 to n do
    for j:= 1 to k do begin
      c[i,j]:=0;
      for l:=1 to m do c[i,j]:=c[i,j]+a[i,l]*b[l,j];
    end; {for j}
end; { MultiplicMatrixs }

procedure AddMatrixs (n,m:byte; a,b:TNMatrix; var c:TNMatrix);
var i,j : byte;
begin
  for i:=1 to n do
    for j:=1 to m do c[i,j]:=a[i,j]+b[i,j];
end; { AddMatrixs }

procedure MultiplicMatVec (n,m:byte; a:TNMatrix; b:TNVector; var c:TNVector);
var i,j : byte;
begin
  for i:=1 to n do begin
    c[i] := 0;
    for j:=1 to m do c[i]:=c[i]+a[i,j]*b[j];
  end;
end; { MultiplicMatVec }

procedure MultiplicVecMat (n,m:byte; a:TNVector; b:TNMatrix; var c:TNVector);
var i,j : byte;
begin
  for i:=1 to m do begin
    c[i] := 0;
    for j:=1 to n do c[i]:=c[i]+a[j]*b[j,i];
  end;
end; { MultiplicVecMat }

procedure MultiplicVecvec (m,n:byte; a,b:TNVector; var c:TNMatrix);
var i,j : byte;
begin
  for i:=1 to m do
    for j:=1 to n do
     c[i,j]:=a[i] * b[j];
end; { MultiplicVecVec }

procedure AddVectors (n:byte; a,b:TNVector; var c:TNVector);
var i : byte;
begin
  for i:=1 to n do c[i]:=a[i]+b[i];
end; {  AddVectors }

function NormaOfMatrix (n,m : byte; a : TNMatrix) : real;
var i,j : byte;
    s   : real;
begin
  s:=0;
  for i:=1 to n do
    for j:=1 to m do
     s:=s+a[i,j]*a[i,j];
  NormaOfMatrix:=Sqrt(s);
end; { NormaOfMatrix }

function NormaOfVector (n : byte; a : TNVector) : real;
var i : byte;
    s : real;
begin
  s:=0;
  for i:=1 to n do
   s:=s+a[i]*a[i];
  NormaOfVector:=Sqrt(s);
end; { NormaOfVector }

function Scalar (n : byte; a,b : TNVector) : real;
var i : byte;
    s : real;
begin
  s:=0;
  for i:=1 to n do
   s:=s+a[i]*b[i];
  Scalar:= s;
end; { Scalar }

function Sled (n : byte; a : TNMatrix) : real;
var i : byte;
    s : real;
begin
  s:=1;
  for i:=1 to n do
   s:=s*a[i,i];
  Sled:= s;
end; { Sled }

end. { MyMatrix }

