{***************************************************************************}
{                :                                 }
{***************************************************************************}

program MNK_Polinom;

uses Crt, Matrix, MatrixEx , InOut, Service,
                  GDriver, GKernel, GShell, GWindow;

var
  NumberParam  : integer;       { ᫮ ࠬ஢                }
  NumberDataXY : integer;       { ᫮  ਬ⠫ 祪 X ,Y }
  Xvec, Yvec      : TNVector;          { 室                 }
  Coeff           : TNVector;          { ࠬ                }
  Ycalc           : TNVector;          {  祭 Y           }
  PowF            : TNVector;          { C⥯   ⮫  F }

  MatrF, MatrFt, MatrFFt : TNMatrix;   { 室 }
  MatrFFtInv, MatrResult : TNMatrix;   {      }

  Dispersion             : real;       { ᯥ }
 
  normFFt, normFFtInv    : real;       {   }

  ConditionNumber        : real;       { ᫮ ᫮ }

  A,B                    : PlotArray;  {  뤠 䨪      }
                                       { ⨯ ।  GDriver }
  OldTextAttr            : byte;
  n, PP                  : integer;
  i, error               : byte;


  procedure  MakeNormVecX ( NumberDataXY       : byte;
                                    var   Xvec : TNVector;
                            var XCentr, XDelta : real);
             { ନ஢  Xvec }
   var
    i   : byte;
  begin
   XCentr := (Xvec[NumberDataXY] + XVec[1]) / 2;
   XDelta := Xvec[NumberDataXY] - XCentr;
   for i := 1 to NumberDataXY do
    Xvec[i] := ( Xvec[i] - XCentr ) / XDelta;
  end; { MakeNormVecX }

  procedure  MakeMatrF ( NumberParam, NumberDataXY : byte;
                                         var MatrF : TNMatrix;
                                              Xvec : TNVector);
             { ନ஢  F        }
   var
      Row, Col        : byte;
      Pow             : integer;
      WorkString      : string;
  begin
    for Col := 1 to NumberParam do begin { ନ㥬   ⮫栬 }
     Str(Col:2,WorkString);
     WorkString:=' C⥯   '+WorkString+'-m c⮫ F  = ';
     ReadIntXY(30,5,WorkString,Pow);   ClearRow(50,5);
     PowF[Col]:=Pow;                 { ࠭ ⥯ ⮫ }
     for Row := 1 to NumberDataXY do begin
        MatrF[Row, Col] :=  PowerRI( Xvec[Row], Pow);
     end;
     ClearRow(30,5);
    end;
  end; { MakeMatrF }

  Procedure MakeDataForGraph(var Xmin,Xmax,YCmin,YCmax:real);
  {  ନ஢ ⮢   (ᯥਬ⠫ )           }
  {   ( 祭) ।   ᨬ 祭 }
  {  ᨢ                                                               }
   var
     x, H, Y : real;
     i,j   : byte;
  begin
   n := 100;
   Xmax := Max(NumberDataXY, XVec);   Xmin := Min(NumberDataXY, XVec);
   H := (Xmax - Xmin) / n;
   X := Xmin;
   for i := 1 to n do
    begin
       A[i, 1] := X;
       Y :=0;
       for j := 1 to NumberParam do
        begin PP:=Round(PowF[j]); Y :=Y+ Coeff[j]*PowerRI(X,PP); end;
       A[i, 2] := Y;
       X := X + H;
       if i=1 then begin  YCmin:=Y; YCmax:=Y;  end
        else begin
         if Y < YCmin then YCmin:=Y;
         if Y > YCmax then YCmax:=Y;
        end;
    end;

    for i := 1 to NumberDataXY do
     begin
       B[i, 1] := Xvec[i];
       B[i, 2] := Yvec[i];
     end;
  end;

  Procedure MakeGraph; { ஥ 䨪 }
   var
    YCmin,YCmax,YEmin,YEmax,Xmin,Xmax,Ymin,Ymax : real;
  begin
                                 {    InitGraphic;   ਣ쭮  }
   InitGraphic('e:\tp\graphix'); { <--   ⠫  ஬ ⠭ }
                                 {     Gdriver, GWindow, GShell .. 筨 !}
   SetForeGroundColor(14);  SetBackGroundColor(1);
   DefineHeader(1, 'MNK');  SetHeaderOn;

   MakeDataForGraph(Xmin,Xmax,YCmin,YCmax);
   { 롮 ᨬ   祭 । ᯥਬ⠫ }
   {   祭                                              }
   YEmax := Max(NumberDataXY, YVec);
   YEmin := Min(NumberDataXY, YVec);
   if YEmin<YCmin then Ymin:=YEmin else Ymin:=YCmin;
   if YEmax>YCmax then Ymax:=YEmax else Ymax:=YCmax;

   Xmax:=Xmax+0.1*(Xmax-Xmin); {  ४஢   }
   Ymax:=Ymax+0.1*(Ymax-Ymin);

   DefineWorld(1, Xmin, Ymin, Xmax, Ymax);
   SelectWorld(1);
   SelectWindow(1);

   DrawBorder;
   DrawAxis(6, 6, 5, 20, 5, 20, 1, 1, True); { 㥬                 }
   DrawPolygon(B, 1, NumberDataXY, -7, 2, 1);{ 室   䨪 }

   ResetAxis;
   DrawPolygon(A, 1, n, 0, 1, 0);            {  祭 }

   WaitPressKey;
   LeaveGraphic;
  end;

begin
  OldTextAttr :=TextAttr;
  ClearTxtScr;
  PutString(20,1,'** MHK **  M    ** ');

  ReadIntXY(30,3,' ᫮ ࠬ஢   = ',NumberParam);
  ReadIntXY(30,4,' ᫮  X,Y            = ',NumberDataXY);
  ReadArr(10,5,'X  ',NumberDataXY, Xvec);
  ReadArr(20,5,'Y  ',NumberDataXY, Yvec);
   {  室 ନ஢ 室  MakeNormVecX }
   {  뢥 祭 XCentr  XDelta                              }
  { MakeNormVecX( NumberDataXY,  Xvec, XCentr, XDelta); }
  MakeMatrF( NumberParam, NumberDataXY, MatrF, Xvec);
  WriteMatr( 30, 5, ' F : ', NumberDataXY, NumberParam, MatrF );
  TransposeMatrix( NumberDataXY, NumberParam, MatrF, MatrFt );
  MultiplicMatrixs
         ( NumberParam, NumberDataXY, NumberParam, MatrFt, MatrF, MatrFFt );
  normFFt := NormaOfMatrix( NumberParam, NumberParam, MatrFFt );
  Inverse( NumberParam, MatrFFt, MatrFFtInv, error );
  if error > 0 then begin
   write (' 訡 饭    - ', error );
   TextAttr := OldTextAttr;
   Halt;
  end;
  normFFtInv := NormaOfMatrix( NumberParam, NumberParam, MatrFFtInv );
  MultiplicMatrixs
     ( NumberParam, NumberParam, NumberDataXY, MatrFFtInv, MatrFt, MatrResult );

{ P蠥 ⥬ ⮤ ⭮  ..  ࠢ 室  }
{   । ᫠ ᫮. ,  ᯮ짮  }
{  Gaussian_Elimination(Dimen, Coefficients, Constants, Solution, Error);    }

  MultiplicMatVec( NumberParam, NumberDataXY, MatrResult, Yvec, Coeff );
  { ନ㥬 室 ப    }
  PutString(2,21,'M Y = ');
  for i := 1 to NumberParam do begin
   if (Coeff[i] < 0) then write ( ' -' ) else
    if i <>1 then write ( ' +' );
   write( Abs( Coeff[i] ):7:4, '*X^', Round(PowF[i]):1);
  end;
  { ।塞  祭 Y  ᯥ }
  MultiplicMatVec( NumberDataXY, NumberParam, MatrF, Coeff, Ycalc );
  Dispersion := 0;   {  筠 ᯥ }
  for i:=1 to NumberDataXY do
   Dispersion := Dispersion + Sqr( Ycalc[i] - Yvec[i] );
  Dispersion := Dispersion / ( NumberDataXY - NumberParam );
  WriteRealXY(10,24, '筠 ᯥ: ', Dispersion, 7, 4 );
  ConditionNumber := normFFtInv*normFFt;  { ᫮ ᫮ }
  WriteRealXY
      (10,23,'᫮ ᫮  Ft*F: ',ConditionNumber, 8, 4);
  WaitPressKey;
  TextAttr := OldTextAttr; { ⠭  梥 ࠭ }
  ClrScr;
  MakeGraph;  { ந 䨪 }
end.
